unit Module1;

interface

uses Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, ImgList, ToolWin, ExtCtrls, CheckLst, Menus,
  ActiveX, Buttons, VBto_Converter;

	function PostMessage(hwnd: Longint; wMsg: Longint; wParam: Longint; lParam: Longint): Longint; stdcall; external user32 name 'PostMessageA';
	function SendMessageVB(hwnd: Longint; wMsg: Longint; wParam: Longint; var lParam: Pointer): Longint; stdcall; external user32 name 'SendMessageA'; overload;
	function SendMessageVB(hwnd: Longint; wMsg: Longint; wParam: Longint; var lParam: AnsiString): Longint; stdcall; external user32 name 'SendMessageA'; overload;
	//function SendMessageVB(hwnd: Longint; wMsg: Longint; wParam: Longint; var lParam: Smallint): Longint; stdcall; external user32 name 'SendMessageA'; overload;
	function FindWindowVB(lpClassName: AnsiString; lpWindowName: AnsiString): Longint; stdcall; external user32 name 'FindWindowA';
	function RegisterWindowMessage(lpString: AnsiString): Longint; stdcall; external user32 name 'RegisterWindowMessageA';
	//function SetWindowLong(hwnd: Longint; nIndex: Longint; dwNewLong: Longint): Longint; stdcall; external user32 name 'SetWindowLongA'; overload;
	function SetWindowLong(hwnd: Longint; nIndex: Longint; dwNewLong: Pointer): Longint; stdcall; external user32 name 'SetWindowLongA'; overload;
	function CallWindowProc(lpPrevWndFunc: Longint; hwnd: Longint; msg: Longint; wParam: Longint; lParam: Longint): Longint; stdcall; external user32 name 'CallWindowProcA';
	procedure setHook();
	procedure unHook();
	procedure connectToLogger32();
	function extInterfaceWindowProc(hw: Longint; uMsg: Longint; wParam: Longint; lParam: Longint): Longint; stdcall;

	//=========================================================
const
	GWL_WNDPROC = -4;
var
	GhW,  //handler to windown form own program - frmMain
        L32Msg,
        L32hWnd, //handler Logger32
        lpPrevWndProc, //handler external proceure  extInterfaceWindowProc
        Logger32TextBoxhWnd: Longint;  //handler window in LOgger32 cooperating by text 
	tBuffer, RadioInUse: AnsiString;
	Connected: Boolean;
	isLogger32There, rejectRetry: Smallint;
        //InputDelay : Integer = 100; //delay after MessageRead in ms


implementation

uses frmMain_;

procedure setHook();
begin
 LpPrevWndProc := SetWindowLong(GhW, GWL_WNDPROC, @extInterfaceWindowProc);
end;

procedure unHook();
var
  tLng: Longint;
begin
  ///tLng := SetWindowLong(GhW, GWL_WNDPROC, lpPrevWndProc);
    tLng := SetWindowLong(GhW, GWL_WNDPROC, Pointer(lpPrevWndProc));
end;

procedure connectToLogger32();
begin
	L32hWnd := FindWindowVB('', 'Logger32');
	if L32hWnd=0 then begin
		frmMain.Caption := 'Logger32 not found';
		frmMain.Timer.Interval := isLogger32There;
		frmMain.Timer.Enabled := true;
	end else begin
		frmMain.Timer.Interval := 0;
		frmMain.Timer.Enabled := false;
		frmMain.Caption := 'Found Logger32';
		// now that Logger32 has been found, we can make sure it keeps focus
		// (if we want to) ...
		// AppActivate "Logger32"
		// try to connect to Logger32
		tBuffer := 'Logger32 1';
		L32Msg := RegisterWindowMessage('Logger32 1');
		PostMessage(L32hWnd, L32Msg, 1, GhW);
		frmMain.Label2.Caption := 'Attempting connection with '+tBuffer;
	end;

end;

function extInterfaceWindowProc(hw: Longint; uMsg: Longint; wParam: Longint; lParam: Longint): Longint;
//function to whom is directed handle screen -- replacing standard procedure operating the screen
begin
 if (uMsg = L32Msg) then
     begin
      case wParam of
       0: begin
           // response to connection request
	   frmMain.Label2.Caption := frmMain.Label2.Caption+#13#10+'Logger32 replied with '+mStr(lParam);
	   if lParam=0 then begin // rejected
	                     Connected := false;
	                     frmMain.Timer.Interval := rejectRetry;
                             frmMain.Timer.Enabled := true;
		            end
                       else begin						// accepted
                             Connected := true;
                             frmMain.Label2.Caption := 'Connected to Logger32 using RegisteredWindowsMessage: '+tBuffer;
    		                  // if you do not want Logger32 to send unsolicited messages
                                  // to the TextBox, then send 0 in the lParam ... like this
                     		  // PostMessage L32hWnd, L32Msg, 2&, 0&
		                  // you will still receive unsolicited freq messages (msg # 100)
                             PostMessage(L32hWnd, L32Msg, 2, frmMain.TextBox.handle);
                               // do you want to receive unsolicited DX Spots?  If so, set
			             		// message 3 lParam to 1
			     //PostMessage(L32hWnd, L32Msg, 3, 1); //if you need receive DX Spots
                             PostMessage(L32hWnd, L32Msg, 3, 0);  //if you dont need receive DX Spots
                  	    end;
          end;
       3: begin
           Logger32TextBoxhWnd := lParam;
         	// Debug.Print "msg 3 " & lParam
          end;
       99: begin
            // Logger32 radio in use
	    RadioInUse := 'Using Radio '+mStr(lParam);
	   end;
       100: begin
             // Frequency
	     // do something with frequency.  It is a Long, and is in HZ!
	     frmMain.Caption := RadioInUse+' - Freq is: '+FormatVB(lParam/1000,'#.000')+' KHz';
	     // Debug.Print "msg 100 " & lParam
	    end;
        101: begin
	      // Debug.Print "Beam heading - " & lParam
	     end;
	105: begin
	      frmMain.Label1_1.Caption := 'Received message 105';
	       // Debug.Print "msg 105 " & lParam
	     end;
        else begin //for case wParam
       end; //case wParam
      end;  //case wParam of
     end //if (uMsg = L32Msg) then begin
else begin
      Result := CallWindowProc(lpPrevWndProc, hw, uMsg, wParam, lParam);
    end;
end;


end.
