//				file	VBto_Converter.pas
// This is a part of the VBto Converter (www.vbto.net). Copyright (C) 2005-2010 StressSoft Company Ltd. All rights reserved.

unit VBto_Converter;

interface

uses
	Controls, Windows, ComCtrls, Graphics, SysUtils, StrUtils, Dialogs, Classes, Math;

 
 function FormatVB(v: LongInt; const vbfmt: AnsiString): AnsiString; overload;
 function FormatVB(v: Double; const vbfmt: AnsiString): AnsiString; overload;
 function FormatVB(s: AnsiString; const vbfmt: AnsiString): AnsiString; overload;
 
 function mStr(d: LongInt): AnsiString; overload;
 function mStr(d: Double): AnsiString; overload;
 function mStr(b: Boolean): AnsiString; overload;
 function mStr(s: AnsiString): AnsiString; overload;
 function mStr(v: Variant): AnsiString; overload;
 function mStr(obj: TObject): AnsiString; overload;


implementation

	//=========================================================

function FormatVB(v: LongInt; const vbfmt: AnsiString): AnsiString; overload;
begin
	Result := IntToStr(v);
end;
function FormatVB(v: Double; const vbfmt: AnsiString): AnsiString; overload;
begin
	Result := FloatToStr(v);
end;
function FormatVB(s: AnsiString; const vbfmt: AnsiString): AnsiString; overload;
begin
	Result := s;
end;


function mStr(d: LongInt): AnsiString;
begin
	Result := IntToStr(d);
	if (d>=0) then Result := ' ' + Result;
end;
function mStr(d: Double): AnsiString;
begin
	Result := FloatToStr(d);
	if (d>=0) then Result := ' ' + Result;
end;
function mStr(b: Boolean): AnsiString; overload ;
begin
	if (b) then Result := ' True'
	else	Result := ' False';
end;
function mStr(s: AnsiString): AnsiString; overload;
begin
	Result := s;
end;
function mStr(v: Variant): AnsiString; overload;
begin
	Result := v;
end;
function mStr(obj: TObject): AnsiString; overload;
begin
	Result := '?';
end;

end.
